import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Scanner;

public class tombraider_tbuzzelli {
	static int[] dr = { -1, 0, 1, 0 }, dc = { 0, -1, 0, 1 };

	public static void main(String[] args) {
		Scanner scan = new Scanner(System.in);
		int N = scan.nextInt(), M = scan.nextInt();
		char[][] mat = new char[N][M];
		HashMap<Integer, Integer> map = new HashMap<>();
		int IDX = 0;
		for (int i = 0; i < N; i++) {
			mat[i] = scan.next().toCharArray();
			for (int j = 0; j < M; j++) {
				if (mat[i][j] == 'V' || mat[i][j] == 'H') {
					map.put(i * M + j, IDX++);
				}
			}
		}

		int[] dir = new int[IDX];
		int[] pos = new int[IDX];
		IDX = 0;
		for (int i = 0; i < N; i++)
			for (int j = 0; j < M; j++)
				if (mat[i][j] == 'V' || mat[i][j] == 'H') {
					pos[IDX] = i * M + j;
					dir[IDX++] = mat[i][j] == 'V' ? 0 : 1;
				}

		boolean[][] noDir = new boolean[2][IDX];
		ArrayList<Integer>[] adj = new ArrayList[IDX];
		for (int i = 0; i < IDX; i++)
			adj[i] = new ArrayList<>();
		for (int i = 0; i < IDX; i++) {
			int r = pos[i] / M, c = pos[i] % M;
			ArrayDeque<Integer> q = new ArrayDeque<>();
			for (int j = 0; j < 4; j++) {
				int rr = r + dr[j], cc = c + dc[j];
				if (rr < 0 | rr >= N || cc < 0 || cc >= M)
					continue;
				q.add(rr);
				q.add(cc);
				q.add(j);
				q.add(j % 2); // startDir
			}

			while (!q.isEmpty()) {
				int rr = q.poll();
				int cc = q.poll();
				int d = q.poll();
				int startDir = q.poll();

				if (mat[rr][cc] == 'V' || mat[rr][cc] == 'H') {
					int other = map.get(rr * M + cc);
					boolean contains = false;
					for (int j = 0; j < adj[i].size(); j += 3) {
						if (adj[i].get(j) == other)
							contains = true;
					}
					if (!contains) {
						adj[i].add(other);
						adj[i].add(startDir);
						adj[i].add(d%2);
					}
					continue;
				} else if (mat[rr][cc] == '#') {
					noDir[startDir][i] = true;
					continue;
				} else if (mat[rr][cc] == '/' || mat[rr][cc] == '\\') {
					int newMoveDir = (mat[rr][cc] == '\\') ? d ^ 1 : d ^ 3;
					int rrr = rr + dr[newMoveDir], ccc = cc + dc[newMoveDir];
					if (rrr < 0 || rrr >= N || ccc < 0 || ccc >= M)
						continue;
					q.add(rrr);
					q.add(ccc);
					q.add(newMoveDir);
					q.add(startDir);
					continue;
				} else {
					int rrr = rr + dr[d], ccc = cc + dc[d];
					if (rrr < 0 || rrr >= N || ccc < 0 || ccc >= M)
						continue;
					q.add(rrr);
					q.add(ccc);
					q.add(d);
					q.add(startDir);
				}
			}
		}

		boolean valid = true;
		for (int i = 0; i < IDX; i++) {
			if (noDir[0][i] && noDir[1][i])
				valid = false;
		}

		boolean[] seen = new boolean[IDX];
		int flips = 0;
		int[] sol = new int[IDX];
		Arrays.fill(sol, -1);
		for (int i = 0; i < IDX; i++) {
			if (seen[i])
				continue;
			seen[i] = true;

			int forced = -1;
			ArrayDeque<Integer> set = new ArrayDeque<>();
			ArrayDeque<Integer> q = new ArrayDeque<>();
			q.add(i);
			while (!q.isEmpty()) {
				int node = q.poll();
				if (noDir[0][node]) {
					forced = node;
					sol[node] = 1;
				}
				if (noDir[1][node]) {
					forced = node;
					sol[node] = 0;
				}
				set.add(node);
				for (int j=0;j<adj[node].size();j+=3) {
					int v = adj[node].get(j);
					int startDir = adj[node].get(j+1);
					int opDir = adj[node].get(j+2);
					if (seen[v])
						continue;
					seen[v] = true;
					q.add(v);
				}
			}
			if(forced==-1) {
				int min = 1000000, minIdx = -1;
				for(int z=0;z<2;z++) {
					q.add(i);
					sol[i] = z;
					while(!q.isEmpty()) {
						int node = q.poll();
						for (int j = 0; j < adj[node].size(); j += 3) {
							int v = adj[node].get(j);
							int startDir = adj[node].get(j + 1);
							int opDir = adj[node].get(j + 2);
							int ans = -1;
							if (sol[node] == startDir)
								ans = opDir;
							else
								ans = opDir ^ 1;

							if (sol[v] != -1) {
								valid &= (ans == sol[v]);
								continue;
							}
							sol[v] = ans;
							q.add(v);
						}
					}
					int cost = 0;
					for (int j : set) {
						cost += (sol[j]!=dir[j])?1:0;
						sol[j] = -1;
					}
					if(cost < min) {
						min = cost;
						minIdx = z;
					}
				}
				forced = i;
				sol[i] = minIdx;
			}
			
			q.add(forced);
			while (!q.isEmpty()) {
				int node = q.poll();
				for (int j = 0; j < adj[node].size(); j += 3) {
					int v = adj[node].get(j);
					int startDir = adj[node].get(j + 1);
					int opDir = adj[node].get(j + 2);
					int ans = -1;
					if (sol[node] == startDir)
						ans = opDir;
					else
						ans = opDir ^ 1;

					if (sol[v] != -1) {
						valid &= (ans == sol[v]);
						continue;
					}
					sol[v] = ans;
					q.add(v);
				}
			}
			
			for (int j : set) {
				flips += (sol[j]!=dir[j])?1:0;
			}
		}
		System.out.println(valid?flips:-1);

	}
}
